# kame2/kame-dat/lib_pool/editor.pl

# $Source: /home/nkon2/public_html/kame2/kame-dat/package/nikki/RCS/editor.pl,v $
# $Id: editor.pl,v 1.1 2003/06/01 10:02:44 nkon Exp $
# $Log: editor.pl,v $
# Revision 1.1  2003/06/01 10:02:44  nkon
# Initial revision
#

$CMD_DISPATCH{'show_editor_new_draft'}        = \&show_editor_new_draft;
$CMD_DISPATCH{'editor_draft_preview'}         = \&editor_draft_preview;
$CMD_DISPATCH{'show_editor_draft'}            = \&show_editor_draft;
$CMD_DISPATCH{'editor_publish'}               = \&editor_publish;

$CMD_DISPATCH{'editor_draft_delete'}          = \&editor_draft_delete;

$CMD_DISPATCH{'show_editor_index'}            = \&show_editor_index;
$CMD_DISPATCH{'editor_edit_article'}          = \&editor_edit_article;
$CMD_DISPATCH{'editor_delete_confirm'}        = \&editor_delete_confirm;
$CMD_DISPATCH{'editor_delete_article'}        = \&editor_delete_article;

# $PARAM->{'_format'}˴Ť
# ε򿷵롣
sub show_editor_new_draft{
#  print STDERR "kame2/kame-dat/lib_pool/editor.pl: show_editor_new_draft\n";

  &_require_editor;

  my $format = $PARAM->{'_format'};
  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my $form_path = &scheme_findfile('format', "$format/form.htm");
  my $form_str = &skel_open($form_path);
#  print STDERR "show_editor_new_draft: \$form_path=$form_path\n";

  my $view_path = &scheme_findfile('format', "$format/view.htm");
  my $view_str = &skel_open($view_path);

  $SKEL->{'form'} = $form_str;
  $SKEL->{'view'} = $view_str;

  my $new_internal = {};
  my $ddkey;

  $DATA_DEF = &convert_load_data_def($scheme, $format) unless $DATA_DEF;
  foreach $ddkey (keys %$DATA_DEF){
    if ($ddkey eq '_scheme'){
      $new_internal->{'_scheme'} = $scheme;
    } elsif ($ddkey eq '_format'){
      $new_internal->{'_format'} = $format;
    } elsif ($ddkey eq '_editor'){
      $new_internal->{'_editor'} = $SCHEME->{'_USER'}->{'user_name'};
    } elsif ($ddkey eq 'time'){
      $new_internal->{'time'}    = time;
    } else {
      $new_internal->{$ddkey} = $DATA_DEF->{$ddkey}->{'default'};
    }
  }

  my $category;
  unless ($new_internal->{'_category'}){
    $scheme =~ /\/(\w+)/;
    $category = $1;
    $new_internal->{'_category'} = $category;
  }

  &convert_internal_2_html($new_internal, $scheme, $format);
  &convert_internal_2_form($new_internal, $scheme, $format);

  &show__skelfile('editor_new_draft.html');
}

# $PARAM->{'_draft_id'} Υɥեȵɽ
sub show_editor_draft{
  my $draft_id = $PARAM->{'_draft_id'};

  &_require_editor;

  my $internal = &_draft_db1_load($draft_id);

  my $format = $internal->{'_format'};
  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my $form_path = &scheme_findfile('format', "$format/form.htm");
  my $form_str = &skel_open($form_path);

  my $view_path = &scheme_findfile('format', "$format/view.htm");
  my $view_str = &skel_open($view_path);

  $SKEL->{'form'} = $form_str;
  $SKEL->{'view'} = $view_str;
  $SKEL->{'_format'} = $format;

  &convert_internal_2_form($internal, $scheme, $format);
  &convert_internal_2_html($internal, $scheme, $format);

  &show__skelfile('editor_draft.html');
}


# եϤɥեȤ¸ơeditor_draft ˥쥯Ȥ롣
sub editor_draft_preview{
#  print STDERR "kame2/kame-dat/lib/editor.pl: editor_draft_preview\n";

  &_require_editor;

  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my $format = $PARAM->{'_format'};
  $PARAM->{'_editor'} = $SCHEME->{'_USER'}->{'user_name'};
  unless ($PARAM->{'_draft_id'}){ $PARAM->{'_draft_id'} = &_get_new_draft_id; }

  my $internal = &convert_form_2_internal($PARAM, $scheme, $format);

  my $draft_id = $internal->{'_draft_id'};

  &_draft_db1_write($internal);
  &redirect_pathinfo("/$scheme/editor_draft.html?_draft_id=$draft_id");
}

# draft ȯԤ롣
# draft -> article ذư롣
sub editor_publish{
  my $draft_id = $PARAM->{'_draft_id'};
#  print STDERR "editor.pl: editor_publish: \$draft_id=$draft_id\n";
  &_require_editor;

  my $format = $PARAM->{'_format'};
  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my $draft_db1 = &_draft_db1_load($draft_id);

  unless ($draft_db1->{'_id'}){
    $draft_db1->{'_id'} = &_get_new_article_id;
  }

  my $article_id = $draft_db1->{'_id'};

  &_move_draft_to_article($draft_db1);

  my $index_db_path = &_get_index_db_path;
  $index_db_path = &untaint($index_db_path);
  my $article_db;

  if (-f $index_db_path){
    $article_db = &db_load($index_db_path, '_id', 1);
  }else {
    $article_db = {};
  }
  $article_db->{$draft_db1->{'_id'}}=$draft_db1;

  &db_write($article_db, $index_db_path);

  &_editor_publish_mail_notify($draft_db1);

#  print STDERR "editor_publish: redirect to $scheme/$article_id/\n";
  &redirect_pathinfo("/$scheme/$article_id/");
}

sub editor_draft_delete{
  my $draft_id = $PARAM->{'_draft_id'};

  my $draft_db_path = &_get_draft_db_path;
  my $draft_db = &db_load($draft_db_path, '_draft_id', 1);

  my $draft_dir = &_get_draft_dir($draft_id);

  $draft_db->{$draft_id} = undef;
  &db_write($draft_db, $draft_db_path);
  &remove_directory($draft_dir);

  my $redirect_str = "$ENV{'PATH_INFO'}/editor_draft_index.html";

  if ($PARAM->{'_REFERER_PATH_INFO'}){
    $redirect_str .= "?_REFERER_PATH_INFO=$PARAM->{'_REFERER_PATH_INFO'}";
  }

  &redirect_pathinfo("$redirect_str");
}


sub show_editor_index{
  &_require_editor;
  &show__skelfile('editor_index.html');
}

sub editor_edit_article{
  my $id = $PARAM->{'_id'};
#  print STDERR "editor_edit_article: \$id=$id\n";
  &_require_editor;

  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my $index_db_path = &_get_index_db_path;
  my $article_db;

  if (-f $index_db_path){
    $article_db = &db_load($index_db_path, '_id', 0);
  }else {
    &die("ASSERTION FAIL __FILE__, __LINE__\n");
  }

  my $draft_id = &_get_new_draft_id;
  &_copy_article_to_draft($draft_id, $article_db, $id);

  &redirect_pathinfo("/$scheme/editor_draft.html?_draft_id=$draft_id");
}

sub editor_delete_confirm{
  my $article_id = $PARAM->{'_id'};
  &_require_editor;

  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my $scheme_dir = $SCHEME->{'_SCHEME'}->{'scheme_dir'};
  my $article_dir = &_get_article_dir($article_id);
  my $article_db1_path = &_get_article_db1_path($article_id);
  my $article_db1 = &db1_load($article_db1_path, 0);

  my $format = $article_db1->{'_format'};

  my $view_path = &scheme_findfile('format', "$format/view.htm");
  my $view_str = &skel_open($view_path);

  $SKEL->{'view'} = $view_str;
  &convert_internal_2_html($article_db1, $scheme, $format);

  &show__skelfile('editor_delete_confirm.html');
}

sub editor_delete_article{
  my $id = $PARAM->{'_id'};
#  print STDERR "editor_delete_article: \$id=$id\n";
  $_require_editor;

  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my $index_db_path = &_get_index_db_path;
  my $article_db;

  if (-f $index_db_path){
    $article_db = &db_load($index_db_path, '_id', 1);
  }else {
    &die("ASSERTION FAIL __FILE__, __LINE__\n");
  }

  my $article_dir = &_get_article_dir($id);
  $article_dir = &untaint($article_dir);

#  print STDERR "editor_delete_article: \$article_dir=$article_dir\n";

  $article_db->{$id} = undef;
  &db_write($article_db, $index_db_path);
  &remove_directory($article_dir);

  &redirect_pathinfo("/$scheme/editor_index.html");
}

sub _draft_db1_load{
  my $draft_id = shift;

  my $draft_dir = &_get_draft_dir($draft_id);
  my $draft_db1_file = "$draft_dir/draft.db1";
  $draft_db1_file = &sanitize_path($draft_db1_file);

  my $draft_db1 = &db1_load($draft_db1_file);

  return $draft_db1;
}

# draft  <homedir>/category/draft/data/<draft_id>/draft.db1 ¸롣
# draft index  <homedir>/category/draft/data/draft.db ¸롣
sub _draft_db1_write{
  my $internal = shift;
  my $draft_id = $internal->{'_draft_id'};

  my $scheme = $internal->{'_scheme'};
  my $format = $internal->{'_format'};

#  print STDERR "editor.pl: _draft_db1_write: \$draft_id = $draft_id\n";

  my $draft_dir = &_get_draft_dir($draft_id, 1);
  my $draft_db1_file = "$draft_dir/draft.db1";
  $draft_db1_file = &sanitize_path($draft_db1_file);

  my $draft_db1 = {};

  my $ddkey;
  my $ddtype;
  my $filename;

  $DATA_DEF = &convert_load_data_def($scheme, $format) unless $DATA_DEF;

  foreach $ddkey (keys %$DATA_DEF){
    $ddtype = $DATA_DEF->{$ddkey}->{'type'};
    $draft_db1->{$ddkey} = $internal->{$ddkey}
  }

  &db1_write($draft_db1, $draft_db1_file);

  my $draft_db_path = &_get_draft_db_path;
  my $draft_db;
  if (-f $draft_db_path){
    $draft_db = &db_load($draft_db_path, '_draft_id', 1);
  } else {
    $draft_db = {};
  }
  $draft_db->{$draft_id} = $draft_db1;
  &db_write($draft_db, $draft_db_path);
}

# draft ε article ˰ư롣(draft Ϻ)
sub _move_draft_to_article{
  my $draft_db1 = shift;

  my $draft_id = $draft_db1->{'_draft_id'};
  my $draft_dir = &_get_draft_dir($draft_id);
  my $draft_db1_file = "$draft_dir/draft.db1";

  my $article_id = $draft_db1->{'_id'};
  my $article_dir = &_get_article_dir($article_id);
  my $article_db1_path = &_get_article_db1_path($article_id);

  unless (-d $article_dir){    &make_directory($article_dir);  }

  &db1_write($draft_db1, $article_db1_path);

  my $scheme = $draft_db1->{'_scheme'};
  my $format = $draft_db1->{'_format'};

  $DATA_DEF = &convert_load_data_def($scheme, $format) unless $DATA_DEF;
  my $ddkey;
  my $ddtype;
  my $image_file;
  my $from_path;
  my $to_path;

  foreach $ddkey (keys %$DATA_DEF){
    $ddtype = $DATA_DEF->{$ddkey}->{'type'};
    if ($ddtype eq 'image'){
      $image_file = $ddkey . ".jpg";
      if (-f "$draft_dir/$image_file"){
        $from_path = "$draft_dir/$image_file";
        $to_path =   "$article_dir/$image_file";
	$from_path = &untaint(&sanitize_path($from_path));
	$to_path   = &untaint(&sanitize_path($to_path));
	&copy_file($from_path, $to_path);
      }
    }
  }

  # draft.db õ
  my $draft_db_path = &_get_draft_db_path;
  $draft_db->{$draft_id} = undef;
  &db_write($draft_db, $draft_db_path);

  $draft_dir = &untaint(&sanitize_path($draft_dir));
  &remove_directory($draft_dir);
}

# ԽѤ article  draft ˥ԡ
sub _copy_article_to_draft{
  my ($draft_id, $article_db, $id) = @_;
#print STDERR "editor.pl:_copy_article_to_draft($draft_id,$article_db,$id)\n";

  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};

  my $internal = $article_db->{$id};
  $internal->{'_draft_id'} = $draft_id;
  my $article_id = $internal->{'_id'};

  my $draft_dir = &_get_draft_dir($draft_id, 1);
  &_draft_db1_write($internal);

  my $article_dir = &_get_article_dir($article_id);

  $DATA_DEF = &convert_load_data_def($scheme, $format) unless $DATA_DEF;
  my $ddkey;
  my $ddtype;
  my $image_file;
  my $from_path;
  my $to_path;

  foreach $ddkey (keys %$DATA_DEF){
    $ddtype = $DATA_DEF->{$ddkey}->{'type'};
    if ($ddtype eq 'image'){
      $image_file = $ddkey . ".jpg";
      if (-f "$article_dir/$image_file"){
        $from_path = "$article_dir/$image_file";
        $to_path =   "$draft_dir/$image_file";
	$from_path = &untaint(&sanitize_path($from_path));
	$to_path   = &untaint(&sanitize_path($to_path));
	&copy_file($from_path, $to_path);
      }
    }
  }

}


sub _editor_publish_mail_notify{
  my $draft_db1 = shift;

  my $to   = $SCHEME->{'_CONFIG'}->{'mail_notify_to'};
  my $subject = "New Article is PUBLISHed";
  my $content = &kame_mail_access_info;

  $content .= <<"TEXT";
ȥ          : $draft_db1->{'subject'}
              : $draft_db1->{'_scheme'}, $draft_db1->{'_id'}
TEXT

  $mail{'From'} = $from;
  $mail{'To'} = $to;
  $mail{'Subject'} = $subject;
  $mail{'Body'} = $content;

  &kame_sendmail(\%mail);

}

sub _get_new_article_id{
  # index.db  scheme_dir Хѥ
  # ǥեȤ data/article.lastid config.db1, lconfig.db1 ˽񤤤ơ
  # ̤ data/article.lastid ˤޤȤ뤳ȤǤ롣
  my $lastid_body = $SCHEME->{'_CONFIG'}->{'last_id_path'};
  $lastid_body ||= "data/article.lastid";

  my $scheme_dir = $SCHEME->{'_SCHEME'}->{'scheme_dir'};

  my $article_id_path = &marge_path($scheme_dir, $lastid_body);

  return &_get_new_id($article_id_path);
}

sub _get_new_draft_id{
  my $draft_home_dir = &_get_draft_home_dir();
  my $draft_id_path = "$draft_home_dir/draft.lastid";

  return &_get_new_id($draft_id_path);
}

sub _get_new_id{
  my $id_path = shift;

#  print STDERR "editor.pl:_get_new_id($id_path)\n";

  $id_path = &sanitize_path($id_path);
  $id_path = &untaint($id_path);

  open(FILE, $id_path) or return &_new_id_file($id_path);
  my $id = <FILE>;
  close(FILE);

  $id ++;

  open(FILE, "> $id_path")
    or &die("editor.pl:_get_new_id: Can't write $id_path:$!\n");
  print FILE $id;
  close(FILE);

#  print STDERR "_get_new_id: \$id = $id\n";

  return $id;
}

sub _new_id_file{
  my $file = shift;

  open(FILE, "> $file")
    or &die("editor.pl:_new_id_file: Can't write $file:$!\n");
  print FILE "1";
  close(FILE);
#  print STDERR "editor.pl:_new_id_file: Create id_count_file $file\n";

  return 1;    # id  1 Ϥ (0 ȵˤʤ)
}

sub _require_editor{
  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};
  my $user_name = $SCHEME->{'_USER'}->{'user_name'};

  unless ($user_name){
#    print STDERR "editor.pl:_require_editor: 桼̾ޤ\n";
    &show__skelfile('user_required.html');
    exit;
  }
  unless(&auth_user_role($user_name, $scheme, 'editor')){
#    print STDERR "editor.pl:_require_editor: 桼 $user_name  $scheme  'editor'ǤϤޤ\n";
    &show__skelfile('user_required.html');
    exit;
  }
}

sub _get_draft_home_dir{
  my $user_name = shift;
  $user_name = $SCHEME->{'_USER'}->{'user_name'} unless $user_name;
#print STDERR "editor.pl:_get_draft_home_dir:\$user_name=$user_name\n";
  my $user_dir = &get_homedir($user_name);
  my $draft_home_dir = "$user_dir/category/draft/data";

  return $draft_home_dir;
}

sub _get_draft_dir{
  my ($draft_id, $is_make) = @_;
  my $draft_home_dir = &_get_draft_home_dir();
  my $draft_dir = "$draft_home_dir/$draft_id";

  if ($is_make){
    unless (-d $draft_dir){
      $draft_dir = &sanitize_path($draft_dir);
      $draft_dir = &untaint($draft_dir);
      &make_directory($draft_dir);
    }
  }
  $draft_dir = &sanitize_path($draft_dir);
  $draft_dir = &untaint($draft_dir);

#  print STDERR "editor.pl:_get_draft_dir:\$draft_dir=$draft_dir\n";
  return $draft_dir;
}

sub _get_article_dir{
  my $article_id = shift;
  my $scheme_dir = $SCHEME->{'_SCHEME'}->{'scheme_dir'};
  my $article_dir = "$scheme_dir/data/$article_id";
  $article_dir = &sanitize_path($article_dir);
  return $article_dir;
}

sub _get_article_db1_path{
  my $article_id = shift;
  my $article_dir = &_get_article_dir($article_id);
  my $article_db1_path = "$article_dir/article.db1";
  $article_db1_path = &sanitize_path($article_db1_path);
  return $article_db1_path;
}

sub _get_index_db_path{
  # index.db  scheme_dir Хѥ
  # ǥեȤ data/index.db config.db1, lconfig.db1 ˽񤤤ơ
  # ̤ data/index.db ˤޤȤ뤳ȤǤ롣
  my $index_db_file_body
    = $SCHEME->{'_CONFIG'}->{'index_db_path'}; # scheme_dir Хѥ
  $index_db_file_body ||= "data/index.db";

  my $scheme_dir = $SCHEME->{'_SCHEME'}->{'scheme_dir'};
  my $index_db_path = &marge_path($scheme_dir, $index_db_file_body);

  print STDERR "editor.pl: _get_index_db_path: \$index_db_path=$index_db_path\n" if $DEBUG;

  return $index_db_path;
}

sub _get_draft_db_path{
  my $draft_home_dir = &_get_draft_home_dir();
  return "$draft_home_dir/draft.db";
}

1;
