# kame-dat/package/navi.pl
# $Id: navi.pl,v 1.3 2003/05/25 12:47:25 nkon Exp $

##############################################
# ɽ --- nave_ex

$SKEL_FUNC{'navi_ex'} = \&skel_func_navi_ex;

sub skel_func_navi_ex{

  my $skel_top_path = &scheme_findfile('skel', "navi_ex_top.htm");
  my $skel_active_path = &scheme_findfile('skel', "navi_ex_active.htm");
  my $skel_normal_path = &scheme_findfile('skel', "navi_ex_normal.htm");

  my $skel_top = &skel_open($skel_top_path);

  my $skel_active = &skel_open($skel_active_path);
  my $skel_normal = &skel_open($skel_normal_path);
  my $scheme = $SCHEME->{'_SCHEME'}->{'scheme'};
  my $pathinfo = $ENV{'PATH_INFO'};

  my $match_str;
  my $match_arg;
  my @key;
  my $key2;
  my $key3;
  my $subst;

  my $top_scheme = $SCHEME->{'_CONFIG'}->{'navi_top'};

  my $count=0;

  while($skel_top =~ /\<navi\s+([^>]+)\>/){
    $match_str = $&;
    $match_arg = $1;
    @key = [];
    @key = split(/\s*,\s*/, $match_arg);
    $subst = &_skel_func_navi_subst($skel_active, $skel_normal,
				    $top_scheme, $pathinfo, \@key);
    $match_str = quotemeta($match_str);
    $skel_top =~ s/$match_str/$subst/eg;
    $count++;
    last if ($count > 100);  # ̵¥롼פɤ
  }

  return $skel_top;
}


sub _skel_func_navi_subst{
  my ($skel_active, $skel_normal, $top_scheme, $pathinfo, $key_ref) = @_;

  my $ret;

  if ($key_ref->[0] =~ /\*$/){     # .* ǥ磻ɤʥޥå
    $match_str = $top_scheme . $key_ref->[0] . ".*";
    if ($pathinfo =~ /$match_str/){
      $ret = $skel_active;
    } else{
      $ret = $skel_normal;
    }
  }else{                           # ʤʥޥå
    if (($top_scheme . $key_ref->[0]) eq $pathinfo){
      $ret = $skel_active;
    } else {
      $ret = $skel_normal;
    }
  }

  my $i;
  my $j;
  for($i = 0; $i < scalar(@$key_ref); $i++){
#    print STDERR "\$key_ref->[$i]=$key_ref->[$i]\n";
    $j = $i+1;
    $ret =~ s/\<arg_$j\>/$key_ref->[$i]/eg;
  }
  $ret =~ s/\<arg_\d\>//g;
  return $ret;
}

##############################################
# TREE ۷

# $navi->{'scheme'}
# $navi->{'rel_path'}
# $navi->{'type'}
# $navi->{'title'}
# $navi->{'child'}=\@

$NAVI_FUNC_GET_TITLE_DIR  = \&navi_get_title_dir_default;
$NAVI_FUNC_GET_TITLE_HTML = \&navi_get_title_html_default;

sub navi_make_tree{
  my $top_scheme = shift;
  my $navi = {};

  $navi->{'scheme'}   = $top_scheme;
  $navi->{'rel_path'} = &_navi_scheme_to_dir($top_scheme);
  $navi->{'type'}     = 'dir';
  $navi->{'title'}    = &$NAVI_FUNC_GET_TITLE_DIR($navi);
  $navi->{'child'}    = &_navi_make_child($top_scheme);

  return $navi;
}

sub _navi_find_child{
  my $top_scheme = shift;
  my @children;

  my $top_scheme_dir = &_navi_scheme_to_dir($top_scheme);
  my $dir;

  # find 'html' children
  my $top_dir = "$this_scheme_dir/skel";
  if (opendir(DIR, $top_dir)){
    foreach $dir (readdir(DIR)){
      next if (($dir eq '.') or ($dir eq '..'));
      next unless ($dir =~ /\.html$/);
      my $navi = {};
      $navi->{'scheme'}   = "$top_scheme/$dir";
      $navi->{'rel_path'} = "$top_dir/$dir";
      $navi->{'type'}     = 'html';
      $navi->{'title'}    = &$NAVI_FUNC_GET_TITLE_HTML($navi);
      $navi->{'child'}    = undef;
      push(@children, $navi);
    }
    closedir(DIR);
  }

  # find subcategory
  my $top_dir = "$this_scheme_dir/category";
  if (opendir(DIR, $top_dir)){
    foreach $dir (readdir(DIR)){
      next if (($dir eq '.') or ($dir eq '..'));
      next unless (-d "$top_dir/$dir");
      my $navi = &navi_make_tree("$top_scheme/$dir");
      push(@children, $navi);
    }
    closedir(DIR);
  }

  # find 'article' children
  my $top_dir = "$this_scheme_dir";
  my $articles = &navi_find_child_article($top_scheme);
  my $key;
  foreach $key (@$articles){
    push(@children, $key);
  }

  return \@children;
}

sub navi_find_child_article{
  my $top_scheme = shift;
  ;
}


#############################################
# 桼ƥƥ

sub _navi_scheme_to_dir{
  my $arg_scheme = shift;
  my $ret;
  my @sc = split('/', $arg_scheme);

  $ret = $DATA_DIR;
  $ret .= join('/category/', @sc);

# print STDERR "navi.pl:_scheme_to_dir($arg_scheme)=>$ret\n";
  return $ret;
}


sub _debug_dump_tree{
  my $tree = shift;
  my $key;

  $_indent++;

  foreach $key (keys %$tree){
    print STDERR " " x $_indent;
    print STDERR "$key => $tree->{$key}\n";
    &_debug_dump_tree($tree->{$key});
  }
  $_indent--;

}


1;

