# kame2/kame-dat/syslib/db_.pl

# $Id: db_.pl,v 1.1 2003/06/09 15:11:10 nkon Exp $
# $Log: db_.pl,v $
# Revision 1.1  2003/06/09 15:11:10  nkon
# Initial revision
#
# Revision 1.1  2003/06/09 15:09:26  nkon
# Initial revision
#

# *** lock С

# db Υեɤ롣
# $db_file: եѥ
# $key_record: 祭Ȥ쥳̾
# $lock: 0=åʤ
sub db_load{
  my ($db_file, $key_record, $lock) = @_;

  my $item_ref = {};
  my $line;

  my $ret_db = {};
  my $key;
  my $value;


  if ($lock){
    &_db_lock($db_file);
  } else {
    &_db_lock_wait($db_file);
  }

  open(FILE, $db_file) or &die("db_load: Can't read $db_file:$!\n");
  while(<FILE>){
    chomp;
    $line = $_;
#    next if ($line =~ /^#/); # Ƭ # ιԤϥȤʤΤɤФ
#	                     # #ʹߤ *ǤϤʤ*Ȥ

    if ($line =~ /^$/){  # Ԥʤ쥳ɤν
      # ԤϢ³ƤǽΤ
      if ($item_ref->{$key_record}){
#print STDERR "db_load: pushing $item_ref->{$key_record}\n";
	$ret_db->{$item_ref->{$key_record}} = $item_ref;
	$item_ref = {};
      }
    } else {
      ($key, $value) = split(':', $line, 2);
#print STDERR "db_load: (\$key, \$value) = ($key, $value)\n";
      $value =~ s/\\\\/\000/g;
      $value =~ s/\\n/\n/g;
      $value =~ s/\000/\\/g;
      $item_ref->{$key} = $value;
    }
  }
  # ǽ쥳ɤĤäƤʤ顢
  if ($item_ref->{$key_record}){
#print STDERR "db_load: pushing $item_ref->{$key_record}\n";
    $ret_db->{$item_ref->{$key_record}} = $item_ref;
  }

  return $ret_db;
}

sub db_write{
  my ($db_ref, $db_file) = @_;
  my $key;

  open(FILE, ">$db_file") or &die("db_write: Can't write $db_file:$!\n");
  foreach $key (keys %$db_ref){
    print FILE &_db_serialize_record($db_ref->{$key});
    print FILE "\n"; # Ԥϥ쥳ɤζڤ
  }
  close(FILE);
  &_db_unlock($db_file);
}


# db1 Υեɤ롣
# $db1_file: եѥ
# $lock: 0=åʤ
sub db1_load{
  my ($db1_file, $lock) = @_;
  my $ret = {};
  my $line;
  my $key;
  my $value;

  if ($lock){
    &_db_lock($db_file);
  } else {
    &_db_lock_wait($db_file);
  }

  open(FILE, $db1_file) or &die("db1_load: Can't read $db1_file:$!\n");
  while(<FILE>){
    chomp;
    $line = $_;

    next if ($line =~ /^#/); # Ƭ # ιԤϥȤʤΤɤФ
	                     # #ʹߤ *ǤϤʤ*Ȥ

    ($key, $value) = split(':', $line, 2);
    next unless $key;
    $value =~ s/\\\\/\000/g;
    $value =~ s/\\n/\n/g;
    $value =~ s/\000/\\/g;
    $ret->{$key} = $value;
  }
  close(FILE);
  return $ret;
}

sub db1_write{
  my ($record_ref, $db1_file) = @_;
  my $key;

#  print STDERR "db1_write: $record_ref\n";

  open(FILE, "> $db1_file") or &die("db1_write: Can't write $db1_file:$!\n");
  print FILE &_db_serialize_record($record_ref);
  close(FILE);
  &_db_unlock($db_file);
}

sub _db_serialize_record{
  my $record_ref = shift;
  my $key;
  my $ret = "";

  foreach $key (keys %$record_ref){
    $value = $record_ref->{$key};
    $value =~ s/\\/\\\\/g;
    $value =~ s/\r\n/\n/g;
    $value =~ s/\n/\\n/g;
    $value =~ s/\r/\\n/g;
    $ret .= "$key:$value\n";
  }

#  print STDERR "_db_serialize_record:\n$ret\n";
  return $ret;
}

# ܥå󥯤Ȥäեåƥ

sub _db_lock{
  my $path = shift;
  my $lock_file = &_db_path_to_lock($path);
  my $wait_time = &_db_wait_time;

  &_db_lock_wait($path);

  my $i;
  for($i = 0; $i < $wait_time; $i++){
    if (symlink($path, $lock_file)){
      $DB_LOCK_FILE{$path};   # Ǿä褦ˡ
      return;
    }
    sleep(1);
    &_db_lock_clean_old($lock_file);
  }
  &die("_db_lock($path): time out\n");
}

sub _db_lock_wait{
  my $path = shfit;
  my $lock_file = &_db_path_to_lock($path);
  my $wait_time = &_db_wait_time;

  my $i;
  for($i = 0; $i < $wait_time; $i++){
    return unless (-l $lock_file);
    sleep(1);
    &_db_lock_clean_old($lock_file);
  }
  &die("_db_lock_wait($path): time out\n");
}

sub _db_unlock{
  my $path = shift;
  my $lock_file = &_db_path_to_lock($path);
  unlink($lock_file);
}

sub _db_path_to_lock{
  my $path = shift;
  return $path . ".lock";
}

sub _db_wait_time{
  my $ret;
  $ret ||= $SCHESME->{'_CONFIG'}->{'lock_wait'};
  $ret ||= 10;    # sec
  return $ret;
}

sub _db_old_time{
  my $ret;
  $ret ||= $SCHESME->{'_CONFIG'}->{'lock_old'};
  $ret ||= 120;   # sec
  return $ret;
}


sub _db_lock_clean_old{
  my $lock_file = shift;

  $create_time = (lstat($lock_file))[9];

  if ((time - $create_time) > &_db_old_time){
    unlink($lock_file);
  }
}

sub db_lock_clean{
  my $lock_file;
  foreach $locked_file (keys %DB_LOCK_FILE){
    &_db_unlock($locked_file);
  }
}

END{ &db_lock_clean;}

1;
