# kame2/kame-dat/syslib/parse_.pl

sub parse_input{
  my $arg = shift;

  if ($arg->{'size_limit'}){
    if ($ENV{'CONTENT_LENGTH'} > $arg->{'size_limit'}){
      &die("input size TOO LARGE\n");
    }
  }

  if ($arg->{'method_limit'}){
    if      ($arg->{'method_limit'} eq 'GET'){
      if ($ENV{'REQUEST_METHOD'} !~ /^GET$/i){
	&die("method type not match\n");
      }
    } elsif ($arg->{'method_limit'} eq 'POST'){
      if ($ENV{'REQUEST_METHOD'} !~ /^POST$/i){
	&die("method type not match\n");
      }
    } elsif ($arg->{'method_limit'} eq 'MULTIPART'){
      if ($ENV{'CONTENT_TYPE'} !~ /multipart\/form\-data/i){
	&die("method type not match\n");
      }
    }
  }

  my $buffer;

  if ($ENV{'REQUEST_METHOD'} =~ /^GET$/i){
    $buffer = $ENV{'QUERY_STRING'};
  } elsif ($ENV{'REQUEST_METHOD'} =~ /^POST$/i){
    # ϥ
    read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  }

# print STDERR "parse_input\n";
# print STDERR "\$ENV{'REQUEST_METHOD'} = $ENV{'REQUEST_METHOD'}\n";
# print STDERR "\$buffer = $buffer\n";


  if ($ENV{'CONTENT_TYPE'} =~ /multipart\/form\-data/){
    &_parse_multipart($buffer);
  } else {
    &_parse_normal($buffer);
  }
}


sub _parse_normal{
  my $buffer = shift;
  my @pairs;
  my $pair;
  local ($name);
  local ($value);

  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs){
    #print STDERR "_parse_normal:\$pair=$pair\n";
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
#    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
#   Faster  http://www.mikeneko.ne.jp/~lab/perl/numerical_transform/
    $value =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
    &jcode::convert(*value, 'euc');
    $PARAM->{$name} = $value;
    # PARAM ϥХ(ϥå)
  }
}

sub _parse_multipart{
  my $buffer = shift;

  my $boundary;
  $buffer =~ /^(.+)\r\n/;
  $boundary = $1;

  my @pairs;
  my $pair;
  my @vars;
  my $name;
  my $fname;
  my $content_type;
  my $file_name;
  my $file_ct;
  @pairs = split(/$boundary/, $buffer);
  foreach $pair (@pairs){
    $pair =~ s/\r\n$/\r\nD_End/;
    @vars = split(/\r\n/, $pair);
    $vars = @vars;
    $data = '';

    # ξ,ե륢åץɤξ
    if (($vars > 4) && ($vars[1] =~ /name\=\"(.+)\"\;\sfilename\=\"(.+)\"/)){
      $name = $1;
      $fname = $2;
      $content_type = $vars[2];

      for($i = 4; $i < $vars; $i++){
	if ($data eq ''){
	  $data = $vars[$i];
	} else {
	  $data .= "\r\n$vars[$i]";
	}
	$data =~ s/\r\nD_End$//;
      }
      $PARAM->{$name} = $data;
      $file_name = $name . "__file";
      $file_ct = $name . "__ct";
      $PARAM->{$file_name} = $fname;
      $PARAM->{$file_ct} = $content_type;
      # ξ罪
    } elsif (($vars > 2) && ($vars[1] =~ /name\=\"(\S+)\"/)){
      $name = $1;
      $value = $vars[3];

      # ʣԤΥƥȥꥢ
      if ($vars > 5){
	$value .= "\r\n";
	for ($i = 4; $i < $vars; $i++){
	  $value .= "$vars[$i]\r\n";
	}
	$value =~ s/\r\nD_End\r\n//;
	$value =~ s/D_End//g;
      }
      &jcode::convert(*value, 'euc');
      $PARAM->{$name} = $value;
    } else {
      ;
# print STDERR "ASSERT FAIL\n";
    }

  }  # end of foreach $pair (......
}


sub parse_copy_to_skel{
  my $key;
  foreach $key (keys %$PARAM){
    $SKEL->{$key} = &sanitize_nohtml($PARAM->{$key});
  }
}



sub parse_debug_dump{
  my $key;

  print STDERR "parse_debug_dump:\n";
  foreach $key (keys %$PARAM){
    print STDERR "$key: $PARAM->{$key}\n";
  }
}

sub parse_dump_env{
  my $key;

  foreach $key (keys %ENV){
    print STDERR "$key: $ENV{$key}\n";
  }
}


1;

