#
# kame-dat/syslib/sanitize_.pl
# $Id: sanitize_.pl,v 1.2 2003/05/01 12:02:38 nkon Exp $
# $Log: sanitize_.pl,v $
# Revision 1.2  2003/05/01 12:02:38  nkon
# sanitize_path ("aaa/bbb;rm -rf")  => NG
#
# Revision 1.1  2003/05/01 11:09:05  nkon
# Initial revision
#

sub sanitize_nohtml{
  my $str = shift;

  $str =~ s/&/&amp;/g;
  $str =~ s/</&lt;/g;
  $str =~ s/>/&gt;/g;
  $str =~ s/"/&quot;/g;
  $str =~ s/'/&#39;/g;

  return $str;
}

sub sanitize_mailaddr{
  my $str = shift;
  return '' if ($str =~ /[^\@A-Za-z0-9\-_.]/);
  return '' if ($str !~ /[A-Za-z0-9_.-]+@[A-Za-z0-9_-]+\.[A-Za-z0-9_.-]+/);
  return $str;
}

sub sanitize_url{
  my $str = shift;

  # ̵ʸä֤
  # http://www.ietf.org/rfc/rfc2396.txt
  # uric = reserved | unreserved | escaped
  # reserved   = ";" | "/" | "?" | ":" | "@" | "&" | "=" | "+" | "$" | ","
  # unreserved = alphanum | mark
  # mark       = "-" | "_" | "." | "!" | "~" | "*" | "7" | "(" | ")"
  # escaped = "%" hex hex
  return '' if ($str =~ m|[^;/?:@&=+$,A-Za-z0-9\-_.!~*'()%]|);

  # ̤ΤΥʤ֤
  # http://www.ietf.org/rfc/rfc2396.txt
  if ($str =~ /^([A-Za-z][A-Za-z0-9+\-.]*):/){
    my $scheme = lc($1);      # ʸѴ
    my $allowed = 0;
    $allowed = 1 if ($scheme eq 'http');
    $allowed = 1 if ($scheme eq 'https');
    $allowed = 1 if ($scheme eq 'mailto');
    $allowed = 1 if ($scheme eq 'ftp');
    return '' unless $allowed;
  }

  # HTML 
#  $str =~ s/&/&amp;/g;
  $str =~ s/'/&#39;/g;

  return $str;
}


# ѥ򸡺롣
sub sanitize_path{
  my $str = shift;
  my $ret;

  $str =~ /(.*)/;
  $ret = $1;          # ޤOK

  if ($ret =~ /["!&'()~|`;*\\]/) { return undef;} # üѥϵѲ

  if ($ret =~ /\/\//){    return undef;  }  # // Ե
  if ($ret =~ /\.\./){    return undef;  }  # .. Ե
  if (($ret =~ /^\//) and
      ($ret !~ /^$DATA_DIR/))     # $DATA_DIR ʳ / ϤޤԵ
                     {    return undef;  }
  if ($ret =~ /[~,:#'"`]/){ return undef;}  # ~,:#'"` Ե

  return $ret;
}

1;
