# kame2/kame-dat/lib/scheme_.pl

sub scheme_config_load{
  my $scheme = shift;

  unless ($scheme){
    $scheme = $PARAM->{'_SCHEME'};
    $SCHEME->{'_SCHEME'}->{'scheme'} = $scheme;
  }

  my @sc = split('/', $scheme);

  my $config_dir;
  my $lib_dir;
  my $sc_item;
  my $sc_path = $DATA_DIR . "/";

  while(1){

    # config/ ǥ쥯ȥβ
    # config.db1, mime.types, skel.db1 ƵŪ˥ɤ롣
    $config_dir = $sc_path . 'config';
#    print STDERR "scheme_load: \$config_dir = $config_dir\n";
    &_scheme_config_load("$config_dir/config.db1")
                               if (-f "$config_dir/config.db1");
    &_scheme_config_load_mime("$config_dir/mime.types")
                               if (-f "$config_dir/mime.types");
    &_scheme_config_load_skel("$config_dir/skel.db1")
                               if (-f "$config_dir/skel.db1");

    # lib/ ǥ쥯ȥβΥե뤿
    # ƵŪ require 롣
    $lib_dir = $sc_path . 'lib';
#    print STDERR "scheme_load: \$lib_dir = $lib_dir\n";
    &_scheme_config_require($lib_dir) if (-d $lib_dir);


    # ǥ쥯ȥĲ롣
    if ($sc_item = shift(@sc)){
      $sc_path .= "category/";
      $sc_path .= $sc_item;
      $sc_path .= "/";
    } else {   # ǥ쥯ȥ
      chop($sc_path);    #  '/' 
      $SCHEME->{'_SCHEME'}->{'scheme_dir'} = $sc_path;

      #ǥ쥯ȥǤ (Ѿʤ)ɤ롣
      &_scheme_config_load("$config_dir/lconfig.db1")
                               if (-f "$config_dir/lconfig.db1");
      &_scheme_config_load_mime("$config_dir/lmime.types")
                               if (-f "$config_dir/lmime.types");
      &_scheme_config_load_skel("$config_dir/lskel.db1")
                               if (-f "$config_dir/lskel.db1");

      last;
    }

  }

}


sub scheme_findfile{
  my ($type, $file, $scheme) = @_;
  $scheme = $PARAM->{'_SCHEME'} unless $scheme;

#  print STDERR "scheme_findfile($type, $file) \$PARAM->{'_SCHEME'} = $PARAM->{'_SCHEME'}\n";

  my @sc = split('/', $scheme);

  my $dir;
  my $sc_item;
  my $sc_path = $DATA_DIR . '/';
  my @files;

  while(1){
    $dir = $sc_path . $type;
#    print STDERR "scheme_findfile: \$dir = $dir\n";
    unshift(@files, "$dir/$file");

    if ($sc_item = shift(@sc)){
      $sc_path .= "category/";
      $sc_path .= $sc_item;
      $sc_path .= "/";
    } else {
      last;
    }
  }

  my $try;
  foreach $try (@files){
#    print STDERR "scheme_findfile: \$try = $try\n";
    if (-f $try){ return $try; }
  }

  ##### ե뤬Ĥʤ
  return &error("scheme_findfile: Can't find file ($type, $file)\n");
}


sub _scheme_config_load{
  my $file = shift;
#  print STDERR "_scheme_config_load($file)\n";

  unless (-f $file){ return; }

  my $db1 = &db1_load($file, 0);
  my $key;

  foreach $key (keys %$db1){
    $SCHEME->{'_CONFIG'}->{$key} = $db1->{$key};
#    print STDERR "_scheme_config_load: $file --> $key:$db1->{$key}\n";
  }
}

sub _scheme_config_load_mime{
  my $file = shift;
#  print STDERR "_scheme_config_load_mime($file)\n";

  unless (-f $file){ return; }

  my $line;
  my @token;
  my $ct;
  my $ext;

  open(FILE, $file)
    or &die("_scheme_config_load_mime: 'Can't read $file:$!\n");
  while(<FILE>){
    $line = $_;
    @token = split('\s+', $line);
    $ct = shift(@token);
    while(@token){
      $ext = shift(@token);
      $SCHEME->{'_MIME_TYPE'}->{$ext} = $ct;
    }
  }
  close(FILE);
}

sub _scheme_config_load_skel{
  my $file = shift;
#  print STDERR "_scheme_config_load_skel($file)\n";

  unless (-f $file){ return; }

  my $db1 = &db1_load($file, 0);
  my $key;
  foreach $key (keys %$db1){
    $SKEL->{$key} = $db1->{$key};
  }
}

sub _scheme_config_require{
  my $lib_dir = shift;
  my $file;
  my $sanitized_path;

#  print STDERR "_scheme_config_require($lib_dir)\n";
  opendir(DIR, "$lib_dir") or return;
  foreach $file (readdir(DIR)){
    next if ($file =~ /^\./);
    next if ($file !~ /\.pl$/);
    $sanitized_path = &sanitize_path("$lib_dir/$file");
    require $sanitized_path;
#    print STDERR "_scheme_config_require \"$lib_dir/$file\"\n";;
  }
  closedir(DIR);
}

sub scheme_ok{
  my $scheme;
  $scheme = $PARAM->{'_SCHEME'} unless $scheme;
  my @sc = split('/', $scheme);

#####  my $scheme_dir = "./kame-dat";
  my $scheme_dir = $DATA_DIR;
  my $i;

  foreach $i (@sc){
    $scheme_dir .= "/category/" . $i;
  }

#  print STDERR "scheme_ok: \$scheme=$scheme, \$scheme_dir=$scheme_dir\n";

  if (-d $scheme_dir){
    return 1;
  } else {
    return 0;
  }
}

sub scheme_debug_dump{
  my $key;
  my $key2;

  print STDERR "scheme_debug_dump:\n";
  foreach $key (keys %$SCHEME){
    if (($key eq '_MIME_TYPE') or
	($key eq '_CONFIG')){
      foreach $key2 (keys %{$SCHEME->{$key}}){
	print STDERR "\$SCHEME->{$key}->{$key2} = $SCHEME->{$key}->{$key2}\n";
      }
    } else {
      print STDERR "\$SCHEME->{$key} = $SCHEME->{$key}\n";
    }
  }
}

1;

