# kame2/kame-dat/syslib/show_.pl

sub show__skelfile{
  my ($file, $scheme) = @_;
  my $skel_file = &scheme_findfile('skel', $file, $scheme);

#  &skel_debug_dump;

#  print STDERR "show__skelfile: \$file=$file => \$skel_file=$skel_file\n";

  my $str = &skel_open($skel_file);
  $str = &skel_var($str);
  $str = &skel_include($str);
  $str = &skel_func($str);
  $str = &skel_subst($str);
  $str = &skel_clean($str);
  &skel_output($str);
  exit;
}

sub show_index{
  &show__skelfile('index.html');
}

sub show_not_found{
  my $not_found_path = &scheme_findfile('skel', 'not_found.html');
  $not_found_path='skel/not_found.html' unless (-f $not_found_path);

  my $url = "http://" . $ENV{'SERVER_NAME'}
          . $ENV{'SCRIPT_NAME'} . $ENV{'PATH_INFO'};
  $SKEL->{'_REFERER_URL'} = $url;

  my $str = &skel_open($not_found_path);
  $str = &skel_subst($str);
  $str = &skel_clean($str);
  &skel_output($str);
  exit;
}

sub show__file{
  my $file = $PARAM->{'_FILE'};
#  print STDERR "show__file: \$PARAM->{'_FILE'} = $PARAM->{'_FILE'}\n";

  my $file_path = &scheme_findfile('file', $file);

  my $lastmod_str = &cookie_time_to_str((stat($file_path))[9]);
  chop($lastmod_str);
# print STDERR "show__file: \$lastmod_str=$lastmod_str\n";
  my @data;

  my $ct = &show_guess_ct($file_path);
  open(FILE, $file_path) or &die("show__file: Can't read $file_path:$!\n");
  @data = <FILE>;
  close(FILE);

  print "Content-type: $ct\n";
  if ($lastmod_str){
    print "Last-Modified: $lastmod_str\n\n";
  } else {
    print "\n";
  }

  print @data;
  exit;
}


sub show_guess_ct{
  my $file = shift;
  my $ext;

  $file =~ /\.(\w+)$/;
  $ext = $1;

  if ($SCHEME->{'_MIME_TYPE'}->{$ext}){
    return $SCHEME->{'_MIME_TYPE'}->{$ext};
  } else {
    return 'application/octed-stream';
  }
}

sub show_article{
  my $scheme = $PARAM->{'_SCHEME'};
  my $article_id = $PARAM->{'_ARTICLE_ID'};
  my $file = $PARAM->{'_FILE'};

#  print STDERR "show_article(\$scheme=$scheme, \$article_id=$article_id, \$file=$file)\n";

  my $scheme_dir = $SCHEME->{'_SCHEME'}->{'scheme_dir'};
  my $article_db1_path = "$scheme_dir/data/$article_id/article.db1";
  $article_db1_path = &sanitize_path($article_db1_path);
  my $article_db1 = &db1_load($article_db1_path);

  $format = $article_db1->{'_format'};

  my $view_path = &scheme_findfile('format', "$format/view.htm");
  my $view_str = &skel_open($view_path);

  $SKEL->{'view'} = $view_str;

  &convert_internal_2_html($article_db1, $scheme, $format);

  &show__skelfile('article.html');
}

sub show_article_file{
  my $scheme = $PARAM->{'_SCHEME'};
  my $article_id = $PARAM->{'_ARTICLE_ID'};
  my $file = $PARAM->{'_FILE'};

#  print STDERR "show_article_file(\$scheme=$scheme, \$article_id=$article_id, \$file=$file)\n";

  my $scheme_dir = $SCHEME->{'_SCHEME'}->{'scheme_dir'};
  my $file_path = "$scheme_dir/data/$article_id/$file";
#  print STDERR "show_article_file: $file_path=$file_path\n";

  my $lastmod_str = &cookie_time_to_str((stat($file_path))[9]);
  chop($lastmod_str);
# print STDERR "show_article_file: \$lastmod_str=$lastmod_str\n";
  my @data;

  my $ct = &show_guess_ct($file_path);
  open(FILE, $file_path)
    or &die("show_article_file: Can't read $file_path:$!\n");
  @data = <FILE>;
  close(FILE);

  print "Content-type: $ct\n\n";
  print @data;
  exit;
}

1;

