# kame2/kame-dat/syslib/skel_.pl

sub skel_open{
  my $skel_file = shift;

  open(FILE, $skel_file) or &error("skel_open: Can't read $skel_file: $!\n");
  local($ret);
  while(<FILE>){
    $ret .= $_;
  }
  close(FILE);
  &jcode::convert(*ret, 'euc');
  return $ret;
}

sub skel_subst{
  my ($str, $skel) = @_;
  $skel = $SKEL unless $skel;

  my $key;
  my $count=0;

  while($str =~ /\<skel\s+(\w+)\>/){
    $match_str = $&;
    $key = $1;
#    print STDERR "skel_subst: \$key=$key, \$value=$skel->{$key}, \$match_str=$match_str\n";
    if (defined $skel->{$key}){
      $str =~ s/$match_str/$skel->{$key}/g;
    } else {
    # defined ǤʤС̤ε˻ȤΤʤΤǥפƤ
      $str =~ s/$match_str/\<_skel $key\>/g;
    }
    $count++;
    last if ($count > 100);  # ̵¥롼פɤ
  }

  # פΤᤷƤ
  while($str =~ /\<_skel\s+(\w+)\>/){
    $match_str = $&;
    $key = $1;
    $str =~ s/$match_str/\<skel $key\>/g;
    $count++;
    last if ($count > 100);  # ̵¥롼פɤ
  }

  return $str;
}

sub skel_clean{
  my $str = shift;
  # פ <skel > ξõ
  $str =~ s/\<skel\s[^>]+\>//g;
  $str =~ s/\<skel_include\s[^>]+\>//g;
  $str =~ s/\<skel_func\s[^>]+\>//g;
  $str =~ s/\<skel_var\s[^>]+\>//g;
  return $str;
}

sub skel_include{
  my $str = shift;
  my $file;
  my $file_path;
  my $subst;
  my $match_str;
  my $count=0;

  while($str =~ /\<skel_include\s+(\w+)\>/){
    $match_str = $&;
    $file = $1 . ".htm";
    $file_path = &scheme_findfile('skel', $file);
    $subst = &skel_open($file_path);
    $str =~ s/$match_str/$subst/eg;
    $count++;
    last if ($count > 100);  # ̵¥롼פɤ
  }
  return $str;
}

sub skel_func{
  my $str = shift;
  my $func;
  my $arg_str;
  my @args;
  my $subst;
  my $match_str;
  my $count = 0;

  while($str =~ /\<skel_func\s+(\w+)\>/){
    $match_str = $&;
    $func = $1;
#    print STDERR "skel_func: \$func=$func\n";
#    print STDERR "skel_func: \$SKEL_FUNC{$func} = $SKEL_FUNC{$func}\n";

    if ($SKEL_FUNC{$func}){
      $subst = &{$SKEL_FUNC{$func}};
      $str =~ s/$match_str/$subst/eg;
    }else {
      print STDERR "skel_func: $func is not found.\n" if $DEBUG;
      $str =~ s/$match_str//g;
    }
    $count++;
    last if ($count > 100);  # ̵¥롼פɤ
  }
  return $str;
}

sub skel_var{
  my $str = shift;
  my $file;
  my $file_path;
  my $subst;
  my $match_str;
  my $count=0;

  while($str =~ /\<skel_var\s+(\w+)\s+([^>]+)\>/){
    $match_str = $&;
    $var_name = $1;
    $var_value = $2;
#print STDERR "skel_var: \$var_name=$var_name, \$var_value=$var_value\n";
    $SKEL->{$var_name} = $var_value;
    $str =~ s/$match_str//g;
    $count++;
    last if ($count > 100);  # ̵¥롼פɤ
  }
  return $str;
}


sub skel_output{
  local ($output_str);
  $output_str = shift;
  &jcode::convert(*output_str, 'jis');

  print "Content-type: text/html;charset=iso-2022-jp\n";

  # COOKIE
  if ($SET_COOKIE){
    my $key;
    foreach $key (keys %$SET_COOKIE){
      next unless $key;
      next unless $SET_COOKIE->{$key};
      print "Set-Cookie: $SET_COOKIE->{$key}\n";
#      print STDERR "skel_output: Set-Cookie: $SET_COOKIE->{$key}\n";
    }
  }
  print "\n";

  print $output_str;
}

sub skel_debug_dump{
  my $key;
  print STDERR "skel_debug_dump:\n";
  foreach $key (keys %$SKEL){
    print STDERR "$key: $SKEL->{$key}\n";
  }
}


1;

