# kame2/kame-dat/syslib/util.pl

# sub die{
#   my $message = shift;
#   print STDERR "DIE: $message\n";
#   exit;
# }

sub die{
  my $message = shift;
  print "Content-type: text/html\n\n";
  print <<"HTML";
<html>
<head>
<title>KAME-Board: SYSTEM ERROR</title>
</head>
<body>
<h1>KAME-Board: SYSTEM ERROR</h1>
$message;
</body></html>
HTML
  exit;
}

sub error{
  my $message = shift;
  print STDERR "kameboard.cgi ERROR: ", $message if $DEBUG;
  return 0;
}

sub access_log{
  my $time = time;
  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
    = localtime($time);
  my $remote_addr = $ENV{'REMOTE_ADDR'};
  my $path_info = $ENV{'PATH_INFO'};
  my $wday_str = (Sun,Mon,Tue,Wed,Thu,Fri,Sat)[$wday];
  my $mon_str  = (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[$mon];

  my $str = sprintf('[%s %s %d %02d:%02d:%02d %04d] %s %s',
		    $wday_str, $mon_str, $mday, $hour, $min, $sec, $year+1900,
		    $remote_addr,
		    $path_info);

  print STDERR "KAME-Board Access Log ", $cookie, $user_name, $str, "\n" if $DEBUG;
}


sub gen_salt{
  my $salt;
  my $itoa64 = "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
  srand;
  $salt = substr($itoa64, int(rand(64)),1);
  $salt .= substr($itoa64, int(rand(64)),1);
  return $salt;
}

use Cwd;

# ǥ쥯ȥ
# -> return 1;  -> return 0;
sub make_directory{
  my $target = shift;

  $target = &untaint($target);

  my @dirs = split('/', $target);

  my $dir;
  foreach $dir (@dirs){
    next if ($dir eq '.');
    unless (-d $dir){
      mkdir($dir, 0777) or return &_sys_return(__FILE__, __LINE__, 0, "Can't make directory $dir:$!\n");
    }
    chdir($dir) or return &_sys_return(__FILE__, __LINE__, 0);
  }

  chdir($CGI_DIR) or return &_sys_return(__FILE__, __LINE__, 0);
  return 1;
}


# ǥ쥯ȥ
# -> return 1;  -> return 0;
sub remove_directory{
  my $target = shift;

  $target = &untaint($target);

  my @dirs = split('/', $target);

  if ($dirs[0] eq ""){
    shift(@dirs);
  }

  if ($dirs[scalar(@dirs)-1] eq ""){
    pop(@dirs);
  }

  my $first_dir = pop(@dirs);
  my $top_dir = join('/', @dirs);

  $top_dir=&untaint($top_dir);

  if ($top_dir){
    chdir($top_dir) or return &_sys_return(__FILE__, __LINE__, 0);
    &_remove_directory2($first_dir)
      or return &_sys_return(__FILE__, __LINE__, 0);
    chdir($CGI_DIR);
  } else {
    &_remove_directory2($first_dir)
      or return &_sys_return(__FILE__, __LINE__, 0);
  }
  return 1;
}

sub _remove_directory2{
  my $target = shift;

  $target = &untaint($target);

  my $files;
  if (-d $target){
    chdir($target) or return &_sys_return(__FILE__, __LINE__, 0);
    opendir(DIR, ".");
    foreach $files (readdir(DIR)){
      next if ($files eq '.');
      next if ($files eq '..');
#      print STDERR "process $files\n";
      if (-d $files){
#	print STDERR "directory $files -> recursive\n";
	&_remove_directory2($files)
	  or return &_sys_return(__FILE__, __LINE__, 0);
	$files = &untaint($files);
      } else {
#	print STDERR "file $files -> unlink\n";
	$files = &untaint($files);
	unlink($files) or return &_sys_return(__FILE__, __LINE__, 0);
      }
    }
    closedir(DIR);
    chdir("..") or return &_sys_return(__FILE__, __LINE__, 0);
    rmdir($target) or return &_sys_return(__FILE__, __LINE__, 0);
  }

  return 1;
}

sub marge_path{
  my ($path1, $path2) = @_;
#  print STDERR "syslib/util.pl:marge_path($path1, $path2)\n";

  my $ret;

  # $path1  / Ǥʤʤդ­
  if (substr($path1, -1,1) ne '/'){ $path1 .= '/'; }

  # $path2 Ƭ / ʤ
  if (substr($path2, 0,1) eq '/'){ substr($path2, 0, 1) = '';}

  # $path2 Ƭ ./ ʤ
  if (substr($path2, 0,2) eq './'){ substr($path2, 0, 2) = '';}


  while(substr($path2, 0, 3) eq '../'){
    # $path2 Ƭ ../ ʤ$path1  ???/ 
    substr($path2, 0, 3) = '';
    $path1 =~ s|/([^/]+/)$|/|;
  }

  $ret = $path1 . $path2;

#  print STDERR "syslib/util.pl:marge_path => $ret\n";

  $ret = &sanitize_path($ret);
  return $ret;
}


sub _sys_return{
  my ($file, $line, $value, $message) = @_;
  print STDERR "util.pl:_sys_return: $message FILE=$file, LINE=$line, $!\n" if $DEBUG;
  return $value;
}

# $from  $to إե򥳥ԡ롣
# $from, $to ϡե̾ޤѥΤȡ
# $from, $to Υǥ쥯ȥϺѤߤΤ
sub copy_file{
  my ($from, $to) = @_;

#  print STDERR "copy_file($from, $to)\n";

  open(FROM, $from) or &die("copy_file: Can't read file $from:$!\n");
  open(TO, "> $to") or &die("copy_file: Can't write file $to:$!\n");
  print TO <FROM>;
  close(TO);
  close(FROM);
}

sub untaint{
  my $str = shift;
  my $ret;
  $str =~ /(.*)/;
  $ret = $1;
  return $ret;
}

sub _debug_is_tainted{
  not eval {
    join('',@_), kill 0;
    1;
  }
}

sub debug_dump_env{
  my $key;
  foreach $key (keys %ENV){
    print STDERR "$key $ENV{$key}\n";
  }
}

sub get_homedir{
  my $user_name = shift;
  my $user_name = &sanitize_path($user_name);
  return "$DATA_DIR/category/user/category/$user_name";
}

sub redirect{
  my $url = shift;

  print "Location:$url\n";

  if ($SET_COOKIE){
    my $key;
    foreach $key (keys %$SET_COOKIE){
      print "Set-Cookie: $SET_COOKIE->{$key}\n";
#      print STDERR "redirect: Set-Cookie: $SET_COOKIE->{$key}\n";
    }
  }

  print "\n";

#  print STDERR "redirect: Location:$url\n";
  exit;
}

sub redirect_pathinfo{
  my $url = shift;
#  print STDERR "redirect_pathinfo($url)\n";

  my $redirect_to = &get_kame_url;
  chop($redirect_to);  # get_kame_url ˤ / դ
  $redirect_to .= $url;
  &redirect($redirect_to);
}

1;


