#!/usr/bin/perl
use Cwd;
use File::Copy;
use File::Path;

# $Id$

###################################################
# 

$KAME_DAT_DIR = "/home/nkon/public_html/kame2-dummy/kame-dat";
#$KAME_DAT_DIR = "/home/nkon/public_html/kame2/kame-dat";
#  kame-dat Хѥ '/' ̵

$USE_SYMLINK = 0;
#  ܥå󥯤ȤʤС1Ȥʤʤ 0(ԡޤ)

# ꤪ
###################################################

sub usage{
  print "usage: install_package.pl <target_category>\n";
  exit;
}

sub lecipe_not_foundusage{
  print "install_package.pl: ./install.dat is not found\n";
  exit;
}


$LECIPE_FILE = 'install.dat';
$TARGET_CATEGORY = @ARGV[0];

&usage unless $TARGET_CATEGORY;

if (scalar(@ARGV) == 2){
  $UNINSTALL = @ARGV[1];
}

open(LECIPE, "$LECIPE_FILE") or &lecipe_not_found;
while(<LECIPE>){
  $line = $_;
  chomp($line);

  ($type, $file) = split(':', $line);

  push(@{$type}, $file);

  if ($type eq 'package'){
    $PACKAGE_NAME = $file;
    next;
  }

  $file{$file} = $file;
}
close(LECIPE);

if ($TARGET_CATEGORY eq '/'){
  $target_dir = $KAME_DAT_DIR;
} else {
  $target_dir = join('/category/', split('/', $TARGET_CATEGORY));
  $target_dir = $KAME_DAT_DIR . '/category/' . $target_dir;
}
print "\$target_dir = $target_dir\n";

unless(-d $target_dir){
  print "ERROR: target_category: dir=$target_dir is not found\n";
#  exit;
}

$target_lib_dir = $target_dir . "/lib";
$target_user_skel_dir = $KAME_DAT_DIR . "/category/user/skel";
$target_user_lib_dir = $KAME_DAT_DIR . "/category/user/lib";
$target_config_dir = $target_dir . "/config";
$target_skel_dir = $target_dir . "/skel";
$target_doc_dir = $KAME_DAT_DIR . "/category/kameboard/category/package/category/" . $PACKAGE_NAME . "/skel";

foreach $file (@lib){
  print STDERR "lib:$file\n";
  unless (-d $target_lib_dir){
    mkpath($target_lib_dir, 1, 0755);
  }
  &install('force', $target_lib_dir, $file);
}

foreach $file (@user_lib){
  print STDERR "user_lib:$file\n";
  unless (-d $target_user_lib_dir){
    mkpath($target_user_lib_dir, 1, 0755);
  }
  &install('isnew', $target_user_lib_dir, $file);
}

foreach $file (@skel){
  unless (-d $target_skel_dir){
    mkpath($target_skel_dir, 1, 0755);
  }
  &install('force', $target_skel_dir, $file);
}

foreach $file (@user_skel){
  unless (-d $target_user_skel_dir){
    mkpath($target_user_skel_dir, 1, 0755);
  }
  &install('isnew', $target_user_skel_dir, $file);
}

foreach $file (@config){
  unless (-d $target_config_dir){
    mkpath($target_config_dir, 1, 0755);
  }
  &install('isnew', $target_config_dir, $file);
}

foreach $file (@config_append){
  unless (-d $target_config_dir){
    mkpath($target_config_dir, 1, 0755);
  }
  &install('isnew', $target_config_dir, $file);
}

foreach $file (@doc){
  unless (-d $target_doc_dir){
    mkpath($target_doc_dir, 1, 0755);
  }
  &install('isnew', $target_doc_dir, $file);
}

sub install{
  my ($type, $dir, $file) = @_;

  my $source_path = $file;
  $file =~ s/^doc\///;
  my $target_path = $dir . '/' . $file;
  my $symsource_path = "";

  my $p;
  foreach $p (reverse(split('/', $dir))){
    last if ($p eq "kame-dat");
    $symsource_path .= "../";
  }
  $symsource_path .= "package/$PACKAGE_NAME/$source_path";

  if ($type eq 'force'){
    print "unlink ($target_path);\n";
    unlink ($target_path);
    if ($USE_SYMLINK){
      print "symlink($symsource_path, $target_path);\n";
      symlink($symsource_path, $target_path);
    } else {
      print "copy($source_path, $target_path);\n";
      copy($source_path, $target_path);
    }
  } elsif ($type eq 'isnew'){
    if (-e $target_path){
      print "target file: $target_path is exist.\n";
      return;
    } else {
      if ($USE_SYMLINK){
	print "symlink($symsource_path, $target_path);\n";
	symlink($symsource_path, $target_path);
      } else {
	print "copy($source_path, $target_path);\n";
	copy($source_path, $target_path);
      }
    }
  }

}

