#!/usr/bin/perl

require '../kame-dat/syslib/db_.pl';
require '../kame-dat/syslib/util.pl';

$good_db1 = {'item1' => 'value1',
	     'item2' => 'value2',
	     'item3' => "value3\nvalue3",
	     'item4' => 'value4:value4',
	     'item5' => "value5\tvalue5",
	     'item6' => "value6\\nvalue6",
	    };

&test_db1_load('test_db/good-1.db1', 1, $good_db1);
&test_db1_load('test_db/good-2.db1', 1, $good_db1);
&test_db1_load('test_db/good-3.db1', 1, $good_db1);

if ($GLOBAL_TEST_FAIL == 0){
  print "ALL TESTS IS SUCCEED!!\n";
} else {
  print "***TESTS FAIL\n";
}


sub test_db1_load{
  my ($db1_path, $answer, $desired) = @_;

  my $test_fail = 0;
  my $ret;

  my $dut_db1 = &db1_load($db1_path, 0);
  if ($answer){
    if ($ret = &compair_db1($dut_db1, $desired)){
      print "\n***TEST FAIL***\n";
      print "compair FAIL\n";
      print "\$ret=$ret\n";
      $test_fail = 1;
      $GLOBAL_TEST_FAIL = 1;
    }
  } else {
    if ($dut_db1){
      print "\n***TEST FAIL***\n";
      print "db1_load SHOUD NOT RETURN VALUE\n";
      $test_fail = 1;
      $GLOBAL_TEST_FAIL = 1;
    }
  }

  if ($test_fail == 0){
    print " ...... OK\n";
  }
}

sub compair_db1{
  my ($a, $b) = @_;
  my $key;
  my $fail = "";

  foreach $key (keys %$a){
    unless($a->{$key} eq $b->{$key}){
      $fail .= "\$a->{$key}=$a->{$key}, \$b->{$key}=$b->{$key}\n";
    }
  }
  foreach $key (keys %$b){
    unless($a->{$key} eq $b->{$key}){
      $fail .= "\$a->{$key}=$a->{$key}, \$b->{$key}=$b->{$key}\n";
    }
  }
  return $fail;
}
