#!/usr/bin/perl -T

require '../kame-dat/syslib/util.pl';
require '../kame-dat/syslib/sanitize_.pl';

# path1, path2, 
&test_marge_path("path1", "path2", "path1/path2");
&test_marge_path("path1", "path2/path3", "path1/path2/path3");
&test_marge_path("path1/path3", "path2", "path1/path3/path2");

&test_marge_path("path1", "path2/path3/", "path1/path2/path3/");
&test_marge_path("path1/", "path2", "path1/path2");
&test_marge_path("path1", "./path2", "path1/path2");

&test_marge_path("path1/path3", "../path2", "path1/path2");
&test_marge_path("path1/path3/path4", "../../path2", "path1/path2");
&test_marge_path("path1", "/path2", "path1/path2");




if ($GLOBAL_TEST_FAIL == 0){
  print "ALL TESTS IS SUCCEED!!\n";
} else {
  print "***TESTS FAIL\n";
}

sub test_marge_path{
  my ($path1, $path2, $desired) = @_;

  my $ret;
  my $test_fail = 0;

  print "&marge_path($path1, $path2)";

  $ret = &marge_path($path1, $path2);

  if ($ret eq $desired){
    print "\t=>  $ret\t.... OK\n";
  } else {
    print "\n*** TEST FAIL ***\n";
    print "     Desired = $desired\n";
    print "     Result  = $ret\n";
    $GLOBAL_TEST_FAIL = 1;
  }
}

