#!/usr/bin/perl

require '../kame-dat/syslib/pathinfo_.pl';


### root directory

&test_pathinfo_parse("",
		     {'_SCHEME' => '',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/",
		     {'_SCHEME' => '',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/index.html",
		     {'_SCHEME' => '',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/1/index.html",
		     {'_SCHEME' => '',
		      '_FILE'   => 'index.html',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show_article'});

&test_pathinfo_parse("/1/image1.jpg",
		     {'_SCHEME' => '',
		      '_FILE'   => 'image1.jpg',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show_article_file'});

&test_pathinfo_parse("/1/file/image1.jpg",
		     {'_SCHEME' => '',
		      '_FILE'   => 'image1.jpg',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/file.html",
		     {'_SCHEME' => '',
		      '_FILE'   => 'file.html',
		      '_CMD'    => 'show_file'});

&test_pathinfo_parse("/file",
		     {'_SCHEME' => '',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/file/",
		     {'_SCHEME' => '',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/file/archive.tar.gz",
		     {'_SCHEME' => '',
		      '_FILE'   => 'archive.tar.gz',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/file/foo.lzh",
		     {'_SCHEME' => '',
		      '_FILE'   => 'foo.lzh',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/file/bar.html",
		     {'_SCHEME' => '',
		      '_FILE'   => 'bar.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/file/kameboard.png",
		     {'_SCHEME' => '',
		      '_FILE'   => 'kameboard.png',
		      '_CMD'    => 'show__file'});

### end root directory


### 1st sub directory <category>
&test_pathinfo_parse("/category",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/category/",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/category/index.html",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/category/1/index.html",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'index.html',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show_article'});

&test_pathinfo_parse("/category/1/image1.jpg",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'image1.jpg',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show_article_file'});

&test_pathinfo_parse("/category/1/file/image1.jpg",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'image1.jpg',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/category/file.html",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'file.html',
		      '_CMD'    => 'show_file'});

&test_pathinfo_parse("/category/file",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/category/file/",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/category/file/archive.tar.gz",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'archive.tar.gz',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/category/file/foo.lzh",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'foo.lzh',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/category/file/bar.html",
		     {'_SCHEME' => 'category',
		      '_FILE'   => 'bar.html',
		      '_CMD'    => 'show__file'});

### end 1st sub directory <category>


### begin 2nd sub directory <sub/category>
&test_pathinfo_parse("/sub/category",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/sub/category/",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/sub/category/index.html",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/sub/category/1/index.html",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'index.html',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show_article'});

&test_pathinfo_parse("/sub/category/1/image1.jpg",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'image1.jpg',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show_article_file'});

&test_pathinfo_parse("/sub/category/1/file/image1.jpg",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'image1.jpg',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/sub/category/file.html",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'file.html',
		      '_CMD'    => 'show_file'});

&test_pathinfo_parse("/sub/category/file",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/sub/category/file/",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/sub/category/file/archive.tar.gz",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'archive.tar.gz',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/sub/category/file/foo.lzh",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'foo.lzh',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/sub/category/file/bar.html",
		     {'_SCHEME' => 'sub/category',
		      '_FILE'   => 'bar.html',
		      '_CMD'    => 'show__file'});

### end 2nd sub directory <sub/category>


### begin special category <admin>
&test_pathinfo_parse("/admin",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/admin/",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/admin/index.html",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/admin/file.html",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'file.html',
		      '_CMD'    => 'show_file'});

&test_pathinfo_parse("/admin/file",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/admin/file/",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/admin/file/archive.tar.gz",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'archive.tar.gz',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/admin/file/foo.lzh",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'foo.lzh',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/admin/file/bar.html",
		     {'_SCHEME' => 'admin',
		      '_FILE'   => 'bar.html',
		      '_CMD'    => 'show__file'});

### end special category <admin>

### begin special category <user>
&test_pathinfo_parse("/user",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/user/",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/user/index.html",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show_index'});

&test_pathinfo_parse("/user/1/index.html",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'index.html',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show_article'});

&test_pathinfo_parse("/user/1/image1.jpg",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'image1.jpg',
		      '_ARTICLE_ID' => '1',
		      '_CMD'    => 'show_article_file'});

&test_pathinfo_parse("/user/file.html",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'file.html',
		      '_CMD'    => 'show_file'});

&test_pathinfo_parse("/user/file",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/user/file/",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'index.html',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/user/file/archive.tar.gz",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'archive.tar.gz',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/user/file/foo.lzh",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'foo.lzh',
		      '_CMD'    => 'show__file'});

&test_pathinfo_parse("/user/file/bar.html",
		     {'_SCHEME' => 'user',
		      '_FILE'   => 'bar.html',
		      '_CMD'    => 'show__file'});

### end special category <user>

if ($GLOBAL_TEST_FAIL == 0){
  print "ALL TESTS IS SUCCEED!!\n";
} else {
  print "***TESTS FAIL\n";
}






sub test_pathinfo_parse{
  my ($pathinfo, $answer) = @_;

  print "&pathinfo_parse(\"$pathinfo\")";

  &pathinfo_parse($pathinfo);

  my $key;

  my $test_fail = 0;

  foreach $key (keys %$answer){
    if ($PARAM->{$key} eq $answer->{$key}){
      ;  # DO nothing
    } else {
      print "\n***TEST FAIL***\n";
      print "    Desired = \$PARAM->{$key} = $answer->{$key}\n";
      print "    Result  = \$PARAM->{$key} = $PARAM->{$key}\n";
      $test_fail = 1;
      $GLOBAL_TEST_FAIL = 1;
    }
  }

  if ($test_fail == 0){
    print " ...... OK\n";
  }
}
