#!/usr/bin/perl
# test suite for kame-dat/syslib/santize_.pl

require '../kame-dat/syslib/sanitize_.pl';

#####
&test_function(sanitize_nohtml, "&", "&amp;");
&test_function(sanitize_nohtml, "<", "&lt;");
&test_function(sanitize_nohtml, ">", "&gt;");
&test_function(sanitize_nohtml, "\"", "&quot;");
&test_function(sanitize_nohtml, "'", "&#39;");

&test_function(sanitize_mailaddr, "kon\@bf.wakwak.com", "");
&test_function(sanitize_mailaddr, "aaa", "");
&test_function(sanitize_mailaddr, "aaa\@bbb", "");
&test_function(sanitize_mailaddr, "aaa\@bbb.ccc", "aaa\@bbb.ccc");
&test_function(sanitize_mailaddr, "aaa\@bbb.ccc.ddd", "aaa\@bbb.ccc.ddd");

&test_function(sanitize_url, "http://aaa.bbb:12/~ccc/ddd.eee?fff=ggg&hhh=iii",
                             "http://aaa.bbb:12/~ccc/ddd.eee?fff=ggg&hhh=iii");
&test_function(sanitize_url, "mailto:aaa@bbb.ccc.ddd",
	                     "mailto:aaa@bbb.ccc.ddd");
&test_function(sanitize_url, "ftp://user:pass@aaa.bbb.ccc/ddd/eee.fff",
	                     "ftp://user:pass@aaa.bbb.ccc/ddd/eee.fff");
&test_function(sanitize_url, "javascript:alert(\"hello\");", "");
&test_function(sanitize_url, "vbscript:MsgBox(\"hello\");", "");
&test_function(sanitize_url, "about:<script>alert(\"hello\");</script>", "");

&test_function(sanitize_path, "path/foo/bar", "path/foo/bar");
&test_function(sanitize_path, "//path/foo/bar", "");
&test_function(sanitize_path, "path//foo/bar", "");
&test_function(sanitize_path, "../../etc/passwd", "");
&test_function(sanitize_path, "path;rm -rf", "");
$DATA_DIR = "./kame-dat";
&test_function(sanitize_path, "/etc/passwd", "");
$DATA_DIR = "/data/dir";
&test_function(sanitize_path, "/data/dir/etc/passwd", "/data/dir/etc/passwd");
&test_function(sanitize_path, "/data/dir/../../etc/passwd", "");
undef $DATA_DIR;

if ($GLOBAL_TEST_FAIL == 0){
  print "ALL TESTS IS SUCCEED!!\n";
} else {
  print "***TESTS FAIL\n";
}

sub test_function{
  my ($func_ref, $input, $desired) = @_;

  my $output = &$func_ref($input);

  if ($output ne $desired){
    print "TEST_FAIL\n";
    print "\$output =$output\n";
    print "\$desired=$desired\n";
    $GLOBAL_TEST_FAIL = 1;
  }
}
