#!/usr/bin/perl

require '../kame-dat/syslib/scheme_.pl';
require '../kame-dat/syslib/db_.pl';
require '../kame-dat/syslib/util.pl';
require '../kame-dat/syslib/sanitize_.pl';


$DATA_DIR = "/home/nkon2/public_html/kame2/kame-dat";

&test_scheme_config_load('',
		  {'admin_mail' => 'nkon@localhost',
		   'sendmail_path' => '/usr/sbin/sendmail'});

&test_scheme_config_load('default',
		  {'admin_mail' => 'nkon@localhost',
		   'sendmail_path' => '/usr/sbin/sendmail'});

################################

&test_scheme_findfile('', 'skel', 'index.html',
	      '/home/nkon2/public_html/kame2/kame-dat/skel/index.html');

&test_scheme_findfile('default', 'skel', 'index.html',
	      '/home/nkon2/public_html/kame2/kame-dat/category/default/skel/index.html');


if ($GLOBAL_TEST_FAIL == 0){
  print "ALL TESTS IS SUCCEED!!\n";
} else {
  print "***TESTS FAIL\n";
}



sub test_scheme_config_load{
  my ($scheme, $answer) = @_;

  print "&scheme_config_load() scheme = $scheme";

  $PARAM->{'_SCHEME'} = $scheme;
  &scheme_config_load;

  my $key;

  my $test_fail = 0;

  foreach $key (keys %$answer){
    if ($SCHEME->{'_CONFIG'}->{$key} eq $answer->{$key}){
      ; # OK --> DO nothing
    } else {
      print "\n***TEST FAIL***\n";
      print "    Desired = \$SCHEME->{'_CONFIG'}->{$key} = $answer->{$key}\n";
      print "    Result  = \$SCHEME->{'_CONFIG'}->{$key} = $SCHEME->{'_CONFIG'}->{$key}\n";
      $test_fail = 1;
      $GLOBAL_TEST_FAIL = 1;
    }
  }

  if ($test_fail == 0){
    print " ...... OK\n";
  }

}

sub test_scheme_findfile{
  my ($scheme, $type, $file, $answer) = @_;

  print "&scheme_findfile($type, $file) scheme = $scheme";

  $PARAM->{'_SCHEME'} = $scheme;
  my $result = &scheme_findfile($type, $file);

  my $test_fail = 0;

  if ($result eq $answer){
    ; # OK --> DO NOTHING
  } else{
    print "\n***TEST FAIL***\n";
    print "    Desired = \$result = $answer\n";
    print "    Result  = \$result = $result\n";
    $test_fail = 1;
    $GLOBAL_TEST_FAIL = 1;
  }

  if ($test_fail == 0){
    print " ...... OK\n";
  }

}

